#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
 
#if STDC_HEADERS
#include <stdlib.h>
#include <string.h>
#else
#include <strings.h>
extern "C" void exit(...);
extern "C" int abs(...);
#endif

#include "compilerApi.h"
#include "strategy.h"

#include "anls_att.h"
#include "detect_comm.h"
#include "indep.h"

extern int getreflevel(SgSymbol * index, SgExpression * expr);

extern Shadow_def * get_defined_shadow(SgSymbol *);
extern int shift_is_ok(SgStatement *s, SgSymbol *arraysymb);
extern int fill_DIM(forall_reference * ref, int dim, detect_DIM & dimstruc);
extern int get_partitioned_dim(Processor_def * pdef, int dim, SgArrayRefExp * array);

//indepcom.cc
extern int detect_indepdo_communication(detect_DIM* dad_x, detect_DIM* dad_y,
                              int* l, int* u, int* stride, int *a0, int *b0,
                              int* a1, int* b1, int *amount) ;
extern int detect_section_communication(detect_DIM* dad_x, detect_DIM* dad_y,SgArrayRefExp *lhsarray,int lpd,SgArrayRefExp *rhsarray,int rpd,int *amount);
extern void fill_shift_section(SgStatement *s,int counter,Shift_def *sdef,int num);

extern void change_scalar_expression(SgStatement * , SgExpression * );

extern void calcExp(SgExpression *exp);
extern void divide_exp(SgExpression *exp);
extern void computeExp(SgExpression *exp);
extern void get_coef(SgExpression *e,SgVarRefExp *var,SgExpression * &a,SgExpression * &b);
extern Distribute_def * get_distdef(SgSymbol * asym);
extern Alignment_def * get_aligndef(SgSymbol * asym);

SgStatement * forall2doloop(SgStatement *s);

stack stk;

Indepdo_reference::Indepdo_reference(int r_a,int r_s):forall_reference(left){
	ref_attrib=r_a;
	body=NULL;
	kept=NULL;
	ref_sequence=r_s;
	added_ref_attrib=0;
	pre_ref=-1;
	counter=-1;   
	lhs_counter=-1;
	partitioned_sub_num=-1;
	pre_sym_ref_num=0;
	for(int i=0;i<MAX_ALIGN_DIM;i++) amount_1[0][i]=0;
	for(int i=0;i<MAX_ALIGN_DIM;i++) amount_1[1][i]=0;
}

int Indepdo_reference::get_ref_attrib(){
	return ref_attrib;
}
//int Indepdo_reference::add_ref_attrib(int r_a){
void Indepdo_reference::add_ref_attrib(int r_a){
	added_ref_attrib|=r_a;
}

int Indepdo_reference::getAmount(int num,int dim){
	return amount_1[num][dim];
}

void Indepdo_reference::setAmount(int num,int dim,int amt){
	amount_1[num][dim]=amt;
	if(!forall_reference::getAmount(dim)){
		if(amount_1[0][dim]||amount_1[1][dim]) forall_reference::setAmount(dim,1);
	}
}

Indepdo_index_def::Indepdo_index_def(){
	loop_cut=0;
}

loop_var::loop_var(SgForStmt *do_loop){
        var_sym=do_loop->symbol();
        start=do_loop->start();
        end=do_loop->end();
        step=do_loop->step();
}

loop_var::loop_var(SgStatement *s){
	if(s->variant()!=FOR_NODE){
		printf("error statement!-----from indep.cc\n");
		return;
	}
	SgForStmt *do_loop=(SgForStmt *)s;
	var_sym=do_loop->symbol();
	start=do_loop->start();
	end=do_loop->end();
	step=do_loop->step();
}

SgSymbol *loop_var::getsymbol(){
	return var_sym;
}

SgExpression *loop_var::get_start(){
	return start;
}

SgExpression *loop_var::get_end(){
	return end;
}

SgExpression *loop_var::get_step(){
	return step;
}

stack * stack::copyPtr(){
	stack *new_stk=new stack;
	(*new_stk).element_num=element_num;
	(*new_stk).flag=flag;
	if(flag==0)
	for(int i=0;i<element_num;i++) (*new_stk).exp[i]=exp[i];
	else
	for(int i=0;i<element_num;i++) (*new_stk).lpvar[i]=lpvar[i];
	return new_stk;
}

void stack::push(SgExpression * e){
	if(flag!=0) flag=0;
	if(element_num==MAX_ELEMENT_NUM){
		printf("Stack is full!---from indep.cc\n");
		return;
	}
	exp[element_num]=e;
	element_num++;
}
void stack::push(loop_var * e){
        if(flag!=1) flag=1;
        if(element_num==MAX_ELEMENT_NUM){
                printf("Stack is full!---from indep.cc\n");
                return;
        }
        lpvar[element_num]=e;
        element_num++;
}
void stack::pop(){
	if(element_num==0){
		printf("Stack is empty!---from indep.cc\n");
		return;
	}
	element_num--;
}
SgExpression * stack::get_exp(int i){
	if(i<0||i>=element_num){
		printf("get_exp error!---from indep.cc\n");
		return NULL;
	}
	if(flag!=0) {
		printf("get_exp error!---from indep.cc\n");
	}
	return exp[i];	
}

void stack::replace_exp(int i,SgExpression *e){
	if(i<0||i>=element_num){
		printf("replace_exp error!---from indep.cc\n");
	}
	if(flag!=0) {
		printf("replace_exp error!---from indep.cc\n");
	}
	exp[i]=e;
}

void stack::delete_exp(int i){
	if(i<0||i>=element_num){
		printf("delete_exp error!---from indep.cc\n");
	}
	if(flag!=0) {
		printf("delete_exp error!---from indep.cc\n");
	}
	for(int j=i;j<element_num-1;j++) exp[j]=exp[j+1];
	element_num--;
}

SgExpression * stack::top_exp(){
	if(flag!=0) printf("top_exp error!----indep.cc\n");
	if(element_num==0) printf("top_exp error!----indep.cc\n");
	element_num--;
        return exp[element_num];
}
loop_var * stack::get_loopvar(int i){
        if(i<0||i>=element_num){
                printf("get_loopvar error!---from indep.cc\n");
                return NULL;
        }
        if(flag!=1) {
                printf("get_loopvar error!---from indep.cc\n");
        }
        return lpvar[i];
}
loop_var * stack::top_loopvar(){
        if(flag!=1) printf("top_loopvar error!----indep.cc\n");
        if(element_num==0) printf("top_loopvar error!----indep.cc\n");
        element_num--;
        return lpvar[element_num];
}

void add_indepdo_index(SgStatement *s,Indepdo_header_def *ihdef){
	ihdef->setindexsymb(s->symbol());
	SgExpression *doHeaderExp=s->expr(0);
	SgExpression *step=doHeaderExp->operand(2);
	if (step!=NULL)
		ihdef->setindextriple(2, step);
	SgExpression *l =  doHeaderExp->operand(1)->operand(1);
	ihdef->setindextriple(0, l);
	SgExpression *u =  doHeaderExp->operand(1)->operand(2);
	ihdef->setindextriple(1, u);
        if(s->childList1(0)->variant()==INDEPENDENT_STMT&&s->childList1(2)->variant()==ENDDO_STMT){
		add_indepdo_index(s->childList1(1),ihdef);
	}
}

void add_indepdo_index(SgStatement * s, SgSymbol * symb)
{
  Indepdo_index_def * iidef = new Indepdo_index_def;
  iidef->setsymbol(symb);
  s->addAttribute(IINDEX_Def,iidef,sizeof(Indepdo_index_def));
}

void analyse_indepdo_header(SgStatement *s){
	Indepdo_header_def * ihdef=new Indepdo_header_def;
	add_indepdo_index(s,ihdef);
	s->addAttribute(IHEDR_Def,ihdef,sizeof(Indepdo_header_def));
	s->addAttribute(INDEPDO_Def,NULL,0);
	for (int i=0; i<ihdef->getindexnumber(); i++) {
	SgSymbol * index=ihdef->getindexsymb(i);
	add_indepdo_index(s, index);
  	}
}

void display_indepdo_header(SgStatement *s){//not used function
	if(s->numberOfAttributes(IHEDR_Def)==0) return;
	Indepdo_header_def * ihdef=(Indepdo_header_def*)s->attributeValue(0,IHEDR_Def);
	for (int i=0; i<ihdef->getindexnumber(); i++) {
                printf("%s\n",ihdef->getindexsymb(i)->identifier());
        }
}

void find_same(SgStatement *s,Indepdo_reference *iref,int count) 
{
int i;
int counter=count;
while(counter){
        Indepdo_reference * pre_iref = (Indepdo_reference *) (s->attributeValue(counter-1,Indepdo_Ref));
        if ( (pre_iref->getexpression()->symbol()->identifier()) == (iref->getexpression()->symbol()->identifier()) )
        {
		iref->pre_sym_ref_num=pre_iref->pre_sym_ref_num+1;
		break;
        }
	counter--;
 }
 for (i=0;i<count; i++) {
        Indepdo_reference * pre_iref = (Indepdo_reference *) (s->attributeValue(i,Indepdo_Ref));
        if ( (*pre_iref->getexpression()) == (*iref->getexpression()) )
        {
		if(pre_iref->get_ref_attrib()&Left_Bit){
			if(pre_iref->getexpression()->numberOfAttributes(CONDITION_ASSIGN)){
			if(iref->getexpression()->numberOfAttributes(CONDITION_ASSIGN)==0&&(iref->get_ref_attrib()&Left_Bit)){
				pre_iref->getexpression()->deleteAllAttribute(CONDITION_ASSIGN);
				pre_iref->add_ref_attrib(iref->get_ref_attrib());
			}
			}
			if(pre_iref->ref_sequence==iref->ref_sequence) pre_iref->add_ref_attrib(iref->get_ref_attrib());
        		iref->pre_ref=i;
               		return;
		}
        }
 }

 //if(!(iref->get_ref_attrib()&Left_Bit))
 for (i=0;i<count; i++) {
        Indepdo_reference * pre_iref = (Indepdo_reference *) (s->attributeValue(i,Indepdo_Ref));
        if ( (*pre_iref->getexpression()) == (*iref->getexpression()) )
        {
//		pre_iref->add_ref_attrib(iref->get_ref_attrib());
        	iref->pre_ref=i;
               	return;
        }
 }
}


int find_and_replace(SgExpression *exp,SgVarRefExp *old,SgExpression * new_exp=NULL){
//if find old in exp ,replace it with new_exp if new_exp is not NULL
  if (exp) {
    switch(exp->variant()) {

    case INT_VAL:
      return(0);
      break;

    case VAR_REF:
      if (*exp==*old){
	if(new_exp) exp->replace(*new_exp);
        return (1);
	}
      else
        return (0);
      break;
    case DDOT:
        return 0;
        break;
    case MINUS_OP:
    case ADD_OP:
      {
        int left, right;
        left=find_and_replace(exp->operand(1),old,new_exp);
        right=find_and_replace(exp->operand(2),old,new_exp);

        return(left+right);
        break;
      };

    case MULT_OP:
    case DIV_OP:
      {
        int left, right;
        left=find_and_replace(exp->operand(1),old,new_exp);
        right=find_and_replace(exp->operand(2),old,new_exp);

        return(left+right);
        break;
      };

    case ARRAY_REF:
    case  FUNC_CALL:
    case  INTRIN_FUNC_CALL:
	return 0;
	break;
    default:
	return 0;
	break;
    }
  }
  return (0);
}

int dec_or_inc(SgExpression *exp,SgVarRefExp *e){
//if e is not in exp return 0
//else if we can judge that exp decreases when e increase return -1
//else if we can judge that exp increases when e increase return 1
//else return -2;which means unknown 
  if (exp) {
    switch(exp->variant()) {

    case INT_VAL:
      return(0);
      break;

    case VAR_REF:
      if (*exp==*e){
        return (1);
	}
      else
        return (0);
      break;
    case DDOT:
        return 0;
        break;
    case MINUS_OP:
      {
        int left, right;
        left=dec_or_inc(exp->operand(1),e);
        right=dec_or_inc(exp->operand(2),e);
	if(left==-2||right==-2) return -2;
        if(left==0) return right*(-1);
	if(right==0) return left;
	if(left==right) return -2;
	return left;
        break;
      };

    case ADD_OP:
      {
        int left, right;
        left=dec_or_inc(exp->operand(1),e);
        right=dec_or_inc(exp->operand(2),e);
	if(left==-2||right==-2) return -2;
        if(left==0) return right;
	if(right==0) return left;
	if(left!=right) return -2;
	return left;
        break;
      };

    case MULT_OP:
      {
        int left, right;
        left=dec_or_inc(exp->operand(1),e);
        right=dec_or_inc(exp->operand(2),e);
        if(left==-2||right==-2) return -2;
        if(left==0){
		if(exp->operand(1)->variant()==INT_VAL){
			if(exp->operand(1)->valueInteger()>0) return right;
			else return right*(-1);
		}
		return -2;
	}
        if(right==0){
		if(exp->operand(2)->variant()==INT_VAL){
			if(exp->operand(2)->valueInteger()>0) return left;
			else return left*(-1);
		}
		return -2;
	}
        return -2;
        break;
      };

    case ARRAY_REF:
    case  FUNC_CALL:
    case  INTRIN_FUNC_CALL:
	return 0;
	break;
    default:
	return 0;
	break;
    }
  }
  return (0);
}


void check_sub_indexvar_ref(SgStatement *s,SgArrayRefExp *array){
	int i,j;
        for(i=0;i<array->numberOfSubscripts();i++){
                SgExpression *sub=array->subscript(i);
                for(j=0;j<s->numberOfAttributes(IINDEX_Def);j++){
                        Indepdo_index_def *idxv=(Indepdo_index_def *)s->attributeValue(j,IINDEX_Def);
                        SgVarRefExp *indexvar_ref=new SgVarRefExp(idxv->getsymbol());
                        if(find_and_replace(sub,indexvar_ref,NULL)){//not really replace
                                if(array->numberOfAttributes(SUB_REFED_INDEXVAR)==0)    array->addAttribute(SUB_REFED_INDEXVAR,NULL,0);
                                return;
                        }
                }
        }
}

void get_sub_arrayexp(SgStatement *body,SgArrayRefExp *array,SgExpression * sub,SgExpression *exp){
switch(exp->variant()){
    case BOOL_VAL:
    case INT_VAL:
    case FLOAT_VAL:
    case DOUBLE_VAL:
    case STRING_VAL:
    case DDOT:
      break;

    case VAR_REF: {
      break;
    };

    case ARRAY_REF: {
	sub->addAttribute(SUB_ARRAYEXP,exp,sizeof(exp)); 
      break;
    };

    case MINUS_OP:
    case ADD_OP:
    case MULT_OP:
    case DIV_OP:
    case EXP_OP:
    case MOD_OP:
    case AND_OP:
    case OR_OP:
    case EQV_OP:
    case NEQV_OP:

    case EQ_OP:
    case NOTEQL_OP:
    case LT_OP:
    case LTEQL_OP:
    case GT_OP:
    case GTEQL_OP: {
      get_sub_arrayexp(body,array,sub,exp->operand(1));
      get_sub_arrayexp(body,array,sub,exp->operand(2));
      break;
    }

    case NOT_OP: {
      get_sub_arrayexp(body,array,sub,exp->operand(1));
      break;
    }
    case FUNC_CALL:
    case INTRIN_FUNC_CALL: {
	printf("Subscript of array reference expression contains function call,not processed currently.\n");
	printf("At line:%d.\n",body->lineNumber());
	printf("The array reference expression is:\n");
	array->unparsestdout();
	printf("\n");
	exit(1);
	break;
	}
    default:
	printf("Subscript of array reference expression contains strange expression.\n");
	printf("At line:%d.\n",body->lineNumber());
	printf("The array reference expression is:\n");
	array->unparsestdout();
	printf("\n");
	exit(1);
	break;
    }
}

void get_indepdo_expression(SgStatement * s,SgStatement *body, SgExpression * expr, int r_a,int r_s);

void analyse_indepdo_arrayref(SgStatement *s,SgStatement *body, Indepdo_reference * iref,int ref_seq){
//this function is used to analyse an array reference in independent do whose
//subscript expressions contain a loop var of do loop which is also in the same
//independent do 
//for example, a HPF program like:

//...
//!HPF$ INDEPENDENT
//do i=1,N
//!HPF$ INDEPENDENT
//	do j=1,M    
//			  |     ...
//		          |     do k=1,Q	<------do loop in independent do
//			  |     	...
// independent do body--->|		C(i,j)=C(i,j)+A(i,k)*B(k,j)
//			  |		...
//   (indepdo_body)	  |     end do
//			  |     ...
//	end do
//end do
// ...

//in the above program  'A(i,k)' and 'B(k,j)' both have an expression 'k' as a
//subscript and 'k' is the loop var of the do loop
//so these two references will be analysed here 

	SgArrayRefExp *array=(SgArrayRefExp *)iref->getexpression();
	int sub_refed_loopvar=0;
//'sub_refed_loopvar' not zero means some subscripts of the reference contains 
//loop var
	if(array->variant()!=ARRAY_REF) return;
	for(int i=0;i<array->numberOfSubscripts();i++){
		SgExpression *oldsub=array->subscript(i);
		SgExpression *sub=array->subscript(i)->copyPtr();
		get_sub_arrayexp(iref->body,array,oldsub,oldsub);
		for(int k=0;k<oldsub->numberOfAttributes(SUB_ARRAYEXP);k++){
			SgArrayRefExp *sub_arrayexp=(SgArrayRefExp *)oldsub->attributeValue(k,SUB_ARRAYEXP);
			get_indepdo_expression(s,body,sub_arrayexp,Right_Bit,ref_seq);
		}
		get_sub_arrayexp(iref->body,array,sub,sub);
		int j=0;
		int this_sub_refed_loopvar=0;
		while(j<s->numberOfAttributes(Indepdo_Ref)){
			Indepdo_reference *pre_iref=(Indepdo_reference *)s->attributeValue(j,Indepdo_Ref);
			if(!(pre_iref->get_ref_attrib()&Left_Bit)){
				j++;
				continue;
			}
			if(pre_iref->getexpression()->variant()==ARRAY_REF){
				if(!oldsub->numberOfAttributes(SUB_ARRAYEXP)){
					j++;
					continue;
				}
				for(int k=0;k<oldsub->numberOfAttributes(SUB_ARRAYEXP);k++){
					SgArrayRefExp *oldsub_arrayexp=(SgArrayRefExp *)oldsub->attributeValue(k,SUB_ARRAYEXP);
					SgArrayRefExp *sub_arrayexp=(SgArrayRefExp *)sub->attributeValue(k,SUB_ARRAYEXP);
					if(sub_arrayexp->numberOfAttributes(REPLACED)) continue;
					SgSymbol *sub_arraysym=sub_arrayexp->symbol();
					if(pre_iref->getexpression()->symbol()->identifier()==sub_arraysym->identifier()||oldsub_arrayexp->numberOfAttributes(SUB_REFED_LOOPVAR)||oldsub_arrayexp->numberOfAttributes(SUB_REFED_INDEXVAR)){
						sub_arrayexp->replace(* new SgValueExp(1));
						sub_arrayexp->addAttribute(REPLACED,NULL,0);
						if(!this_sub_refed_loopvar){
	                        	                this_sub_refed_loopvar=1;
        	                        	}
					}
				}
			}
			else{
				SgVarRefExp *loopvar_ref=(SgVarRefExp *)(pre_iref->getexpression());
				if(!(find_and_replace(sub,loopvar_ref,NULL))) {j++;continue;};
				if(!this_sub_refed_loopvar){
					this_sub_refed_loopvar=1;
				}
				SgExpression *start=NULL;
				for(int l=0;l<stk.elements();l++){
					loop_var *lpv=stk.get_loopvar(l);
					SgVarRefExp *lpexp=new SgVarRefExp(lpv->getsymbol());
					if(*loopvar_ref==*lpexp){
						start=lpv->get_start()->copyPtr();
						break;
					}
				}
				if(start) find_and_replace(sub,loopvar_ref,start);
				else
					find_and_replace(sub,loopvar_ref,new SgValueExp(1));
			}
			j++;
		}
		if(!this_sub_refed_loopvar) continue;
		if(!sub_refed_loopvar) sub_refed_loopvar=1;
		SgExpression *sub_range;
		SgExpression * range;
		sub=calculateExp(sub);
		range=new SgExpression(RANGE_OP,sub,get_ubound(array->symbol(),i),NULL);
		sub_range= new SgExpression(DDOT,range,NULL,NULL);
		array->subscript(i)->addAttribute(SUB_RANGE,sub_range,sizeof(sub_range));
	}
	if(sub_refed_loopvar&&array->numberOfAttributes(SUB_REFED_LOOPVAR)==0){
		array->addAttribute(SUB_REFED_LOOPVAR,NULL,0);
		array->addAttribute(LOOPVAR_STK,stk.copyPtr(),sizeof(stack));
	}
}

void get_indepdo_expression(SgStatement * s,SgStatement *body, SgExpression * expr, int r_a,int r_s)
{
  if(expr) {

    switch(expr->variant()) {
    case BOOL_VAL:
    case INT_VAL:
    case FLOAT_VAL:
    case DOUBLE_VAL:
    case STRING_VAL:
      break;

    case VAR_REF: {
	Indepdo_reference * iref= new Indepdo_reference(r_a,r_s);
      iref->setExpr(expr);
	iref->body=body;
      iref->counter=s->numberOfAttributes(Indepdo_Ref);
      s->addAttribute(Indepdo_Ref,(void *)iref, sizeof(Indepdo_reference));
      break;
    };

    case ARRAY_REF: {
	Indepdo_reference * iref= new Indepdo_reference(r_a,r_s);
      iref->setExpr(expr);
	iref->body=body;
	iref->kept=expr->copyPtr();
	analyse_indepdo_arrayref(s,body,iref,r_s);
			//dispose arrayref whose subscripts contains 
			//loop var of the do loop in independent do
			//or array reference expression
      check_sub_indexvar_ref(s,(SgArrayRefExp *)expr);
      iref->counter=s->numberOfAttributes(Indepdo_Ref);
      s->addAttribute(Indepdo_Ref,(void *)iref, sizeof(Indepdo_reference));
      break;
    };

    case MINUS_OP:
    case ADD_OP:
    case MULT_OP:
    case DIV_OP:
    case EXP_OP:
    case MOD_OP:
    case AND_OP:
    case OR_OP:
    case EQV_OP:
    case NEQV_OP:

    case EQ_OP:
    case NOTEQL_OP:
    case LT_OP:
    case LTEQL_OP:
    case GT_OP:
    case GTEQL_OP: {
      get_indepdo_expression(s,body, expr->operand(1), r_a,r_s);
      get_indepdo_expression(s,body, expr->operand(2), r_a,r_s);
      break;
    }

    case NOT_OP: {
      get_indepdo_expression(s,body, expr->operand(1), r_a,r_s);
      break;
    }
    case DDOT:
      break;

    case IMPLIED_DO:{
      SgExpression *loopvar=new SgVarRefExp(expr->symbol());
      get_indepdo_expression(s,body,loopvar,LR_Bit,r_s);
	}	
      	
    case EXPR_LIST:{
      get_indepdo_expression(s,body,expr->operand(1), r_a,r_s);
      get_indepdo_expression(s,body, expr->operand(2), r_a,r_s);
	break;
	}
	
    case FUNC_CALL:
    case INTRIN_FUNC_CALL: {
	SgFunctionRefExp * funExp = (SgFunctionRefExp *) expr;
	Indepdo_header_def *ihdef=(Indepdo_header_def *)s->attributeValue(0,IHEDR_Def);
	if (((SgFunctionSymb*)funExp->symbol())->is_elementary_function()){
		for (int i=0; i<funExp->numberOfArgs(); i++)
			get_indepdo_expression(s,body,  funExp->arg(i),r_a,r_s);
	}
	else {
		for (int i=0; i<funExp->numberOfArgs(); i++) {
 			for (int j=0; j<ihdef->getindexnumber(); j++) {
                		SgSymbol *indexsymb=ihdef->getindexsymb(j);
                		SgExpression *exp;
		                exp = funExp->arg(i)->IsSymbolInExpression(*indexsymb);
        		        if (exp) change_scalar_expression(s->controlParent(),exp);
        		}
		};
		body->addAttribute(FUNC_EXP,funExp,sizeof(funExp));
	}
	break;
	}
    default:
      printf("Not processed expression in independent do!\n");
      ASSERT(0);
      exit(1);
    };
  };
}

void find_condition_assign(SgStatement *body){
		SgStatement *p_s=body->controlParent();
		while(p_s->variant()==LOGIF_NODE||p_s->variant()==ELSEIF_NODE){
			int *ref_flag=new int[body->numberOfAttributes(POTENTIAL_CONDITION_ASSIGN)];
			for(int k=0;k<body->numberOfAttributes(POTENTIAL_CONDITION_ASSIGN);k++){
			ref_flag[k]=0;
			}
			for(int k=0;k<p_s->numberOfAttributes(POTENTIAL_CONDITION_ASSIGN);k++){
			SgExpression *p_exp=(SgExpression *)p_s->attributeValue(k,POTENTIAL_CONDITION_ASSIGN);
			if(p_exp->numberOfAttributes(CONDITION_ASSIGN)) continue;
			int found=0;
			for(int j=0;j<body->numberOfAttributes(POTENTIAL_CONDITION_ASSIGN);j++){
				SgExpression *exp=(SgExpression *)body->attributeValue(j,POTENTIAL_CONDITION_ASSIGN);
				if(exp->numberOfAttributes(CONDITION_ASSIGN)) continue;
				if(*exp==*p_exp){ found=1;ref_flag[j]=1; }
			}	
			if(!found) p_exp->addAttribute(CONDITION_ASSIGN,NULL,0);
		}
		for(int j=0;j<body->numberOfAttributes(POTENTIAL_CONDITION_ASSIGN);j++){
			SgExpression *exp=(SgExpression *)body->attributeValue(j,POTENTIAL_CONDITION_ASSIGN);
			if(exp->numberOfAttributes(CONDITION_ASSIGN)) continue;
			if(!ref_flag[j]) exp->addAttribute(CONDITION_ASSIGN,NULL,0);
		}
		p_s=p_s->controlParent();
	}
}

int is_touchable_arg(SgArrayRefExp *array){
        SgSymbol *arraysym=array->symbol();
        Distribute_def *ddef=get_distdef(arraysym);
        Alignment_def *adef=get_aligndef(arraysym);
        if(!ddef) return 1;
        if(array->numberOfSubscripts())
        for(int i=0;i<array->numberOfSubscripts();i++){
                if(array->subscript(i)->variant()==DDOT){
                        int distdim=adef?adef->getAlignPair(i):i;
                        if(ddef->distCode(distdim)!=NOP) return 0;
                }
        }
        else
        for(int i=0;i<((SgArrayType *)arraysym->type())->dimension();i++){
                int distdim=adef?adef->getAlignPair(i):i;
                if(ddef->distCode(distdim)!=NOP) return 0;
        }
        return 1;
}

void analyse_indepdo_body(SgStatement *s,SgStatement *body,int &ref_seq){ 
		switch(body->variant()){
		case ASSIGN_STAT:
			ref_seq++;
			get_indepdo_expression(s,body,  body->expr(0), Left_Bit,ref_seq);
			get_indepdo_expression(s,body,  body->expr(1), Right_Bit,ref_seq);
			break;
		case PROC_STAT:{
			ref_seq++;
			SgCallStmt *call;
			SgFunctionSymb * prochedr;
			SgFunctionCallExp *proc_call;
			call=(SgCallStmt *)body;
			call->addAttribute(OLD_STMT,call->copyPtr(),sizeof(SgCallStmt));
			proc_call = (SgFunctionCallExp *)body->expr(0);
			prochedr=(SgFunctionSymb *)proc_call->rhs()->symbol();
			int j;
			for(j=0;j<call->numberOfArgs();j++){
				int l=s->numberOfAttributes(Indepdo_Ref);
				if(prochedr->parameter(j)->attributes()&IN_BIT){
					get_indepdo_expression(s,body, call->arg(j),Right_Bit,ref_seq);
				}
				else{
					get_indepdo_expression(s,body, call->arg(j),LR_Bit,ref_seq);
				}
					if(prochedr->parameter(j)->type()->variant()==T_ARRAY){
					SgArrayRefExp *array=(SgArrayRefExp *)call->arg(j);
				        if(!is_touchable_arg(array)) {
		        		        printf("Array section which strides across processors is used as argument of call statement in independent do,which is prohibited in p_HPF currently.If you have more problems please contact huang qi jun.\n");
		                		printf("At line : %d\n",call->lineNumber());
		               			printf("The call statement is:\t");
				                call->unparsestdout();
        	        			printf("The array reference is:\t");
			                	array->unparsestdout();
	                			printf("\n");
			        	        exit(1);
				        }

					call->arg(j)->addAttribute(Array_Arg_num,new int(j),sizeof(j));
					call->arg(j)->addAttribute(Call_Stmt_of_arrayref,call,sizeof(call));
					SgSymbol *procname=proc_call->symbol();
					s->addAttribute(INDEPDO_Call_stmt_with_Arrayref,body,sizeof(body));
				}					
			}
			proc_call->symbol()->addAttribute(CALLED_IN_INDEP,NULL,0);
			break;
			}
		case FOR_NODE:{
			loop_var *p=new loop_var(body);
			stk.push(p);
			SgVarRefExp *loopvar=new SgVarRefExp(body->symbol());
			ref_seq++;
			get_indepdo_expression(s,body,loopvar,Left_Bit,ref_seq);
			int i;
			for(i=0;i<body->numberOfChildrenList1();i++){
				analyse_indepdo_body(s,body->childList1(i),ref_seq);
			}
			break;
			}
		case PRINT_STAT:{
			ref_seq++;
			get_indepdo_expression(s,body, body->expr(1),Right_Bit,ref_seq);
			break;
			}
		case LOGIF_STMT:{
			ref_seq++;
			get_indepdo_expression(s,body, body->expr(0),Right_Bit,ref_seq);
			int i,ref_count;
			ref_count=s->numberOfAttributes(Indepdo_Ref);
			for(i=0;i<body->numberOfChildrenList1();i++){
				analyse_indepdo_body(s,body->childList1(i),ref_seq);
			}
			for(i=ref_count;i<s->numberOfAttributes(Indepdo_Ref);i++){
				Indepdo_reference *iref=(Indepdo_reference *)s->attributeValue(i,Indepdo_Ref);
				SgExpression *exp=iref->getexpression();
				if(exp->variant()==ARRAY_REF&&(iref->get_ref_attrib()&Left_Bit))
				exp->addAttribute(CONDITION_ASSIGN,NULL,0);
			}
			break;
			}
		case LOGIF_NODE:{
			ref_seq++;
			get_indepdo_expression(s,body, body->expr(0),Right_Bit,ref_seq);
			int i,ref_count;
			ref_count=s->numberOfAttributes(Indepdo_Ref);
			for(i=0;i<body->numberOfChildrenList1();i++){
				analyse_indepdo_body(s,body->childList1(i),ref_seq);
			}
			for(i=ref_count;i<s->numberOfAttributes(Indepdo_Ref);i++){
				Indepdo_reference *iref=(Indepdo_reference *)s->attributeValue(i,Indepdo_Ref);
				SgExpression *exp=iref->getexpression();
				if(exp->numberOfAttributes(CONDITION_ASSIGN)) continue;
				if(exp->variant()==ARRAY_REF&&(iref->get_ref_attrib()&Left_Bit))
				body->addAttribute(POTENTIAL_CONDITION_ASSIGN,exp,sizeof(exp));
			}
			ref_count=s->numberOfAttributes(Indepdo_Ref);
			for(i=0;i<body->numberOfChildrenList2();i++){
                                analyse_indepdo_body(s,body->childList2(i),ref_seq);
                        }
			SgStatement *first_child=body->childList2(0);
			if(first_child->variant()!=ELSEIF_NODE){
			for(i=ref_count;i<s->numberOfAttributes(Indepdo_Ref);i++){
				Indepdo_reference *iref=(Indepdo_reference *)s->attributeValue(i,Indepdo_Ref);
				SgExpression *exp=iref->getexpression();
				if(exp->numberOfAttributes(CONDITION_ASSIGN)) continue;
				if(exp->variant()==ARRAY_REF&&(iref->get_ref_attrib()&Left_Bit))
				first_child->addAttribute(POTENTIAL_CONDITION_ASSIGN,exp,sizeof(exp));
			}
			find_condition_assign(first_child);
			}
			break;
			}
		case ELSEIF_NODE:{
			ref_seq++;
			get_indepdo_expression(s,body, body->expr(0),Right_Bit,ref_seq);
			int i,ref_count;
			ref_count=s->numberOfAttributes(Indepdo_Ref);
			for(i=0;i<body->numberOfChildrenList1();i++){
				analyse_indepdo_body(s,body->childList1(i),ref_seq);
			}
			for(i=ref_count;i<s->numberOfAttributes(Indepdo_Ref);i++){
				Indepdo_reference *iref=(Indepdo_reference *)s->attributeValue(i,Indepdo_Ref);
				SgExpression *exp=iref->getexpression();
				if(exp->numberOfAttributes(CONDITION_ASSIGN)) continue;
				if(exp->variant()==ARRAY_REF&&(iref->get_ref_attrib()&Left_Bit))
				body->addAttribute(POTENTIAL_CONDITION_ASSIGN,exp,sizeof(exp));
			}
			find_condition_assign(body);
			ref_count=s->numberOfAttributes(Indepdo_Ref);
			for(i=0;i<body->numberOfChildrenList2();i++){
                                analyse_indepdo_body(s,body->childList2(i),ref_seq);
                        }
			SgStatement *first_child=body->childList2(0);
			if(first_child->variant()!=ELSEIF_NODE){
			for(i=ref_count;i<s->numberOfAttributes(Indepdo_Ref);i++){
				Indepdo_reference *iref=(Indepdo_reference *)s->attributeValue(i,Indepdo_Ref);
				SgExpression *exp=iref->getexpression();
				if(exp->numberOfAttributes(CONDITION_ASSIGN)) continue;
				if(exp->variant()==ARRAY_REF&&(iref->get_ref_attrib()&Left_Bit))
				first_child->addAttribute(POTENTIAL_CONDITION_ASSIGN,exp,sizeof(exp));
			}
			find_condition_assign(first_child);
			}
			break;
			}
		case FORALL_STMT:{
			SgStatement * new_body=forall2doloop(body);
			analyse_indepdo_body(s,new_body,ref_seq);
			break;
			}
			
		case CONTROL_END:
			break;
		case ENDDO_STMT:
			stk.pop();
			break;
		case ASSGOTO_NODE:
		case COMGOTO_NODE:
  		case GOTO_NODE:
  		case CONTINUE_NODE:
			break;
		default:
			printf("********Not processed independent do!*******\n");
		}
	if(body->numberOfAttributes(FUNC_EXP)) s->addAttribute(INDEPDO_stmt_with_FUNC,body,sizeof(body));

}

Distribute_def * get_distdef(SgSymbol * asym){
	if(asym->numberOfAttributes(Align_Def)!=0){
        	Alignment_def * adef = (Alignment_def *)(asym->attributeValue(0,Align_Def));
	        SgSymbol * t = adef->gettosymbol();
       		return (Distribute_def *)t->attributeValue(0, Dist_Def);
	}
	else{
		if(asym->numberOfAttributes(Dist_Def)!=0){
			return (Distribute_def *)asym->attributeValue(0,Dist_Def);
		}
		return NULL;//all collapsed!
	}
}

Alignment_def * get_aligndef(SgSymbol * asym){
	if(asym->numberOfAttributes(Align_Def)!=0){
        	Alignment_def * adef = (Alignment_def *)(asym->attributeValue(0,Align_Def));
		return adef;
	}
	else{
		return NULL;
	}
}

void calc_communication_cost(SgStatement *s,Indepdo_reference *iref){
	SgExpression *array=iref->getexpression();
	int *cost=new int[5];
	stack stk;
	for(int i=0;i<5;i++) cost[i]=0;
	for(int i=0;i<s->numberOfAttributes(Indepdo_Ref);i++){
		Indepdo_reference *iref=(Indepdo_reference *)s->attributeValue(i,Indepdo_Ref);
		switch(iref->getCommunication()){
		case NONE:
			cost[0]++;
			break;
		case SHIFT:{
			SgArrayRefExp * arrayExp=(SgArrayRefExp * ) iref->getexpression();	
			int found=0;
			for(int k=0;k<stk.elements();k++){
				SgArrayRefExp *pre_arrayExp=(SgArrayRefExp *)stk.get_exp(k);
				if(arrayExp->symbol()->identifier()==pre_arrayExp->symbol()->identifier()){ found=1;break;}
			}
			if(!found){ cost[1]++;stk.push(arrayExp); }
			break;
			}
		case REMAP:
			cost[2]++;
			break;
		case UNKNOW:
			cost[3]++;
			break;
		case IRREG:
			cost[4]++;
			break;
		}
	}
	array->addAttribute(COM_COST,cost,sizeof(cost));
}

void recover_indepdo_reference(SgStatement *s){
	for(int i=0;i<s->numberOfAttributes(Indepdo_Ref);i++){
		Indepdo_reference *iref=(Indepdo_reference *)s->attributeValue(i,Indepdo_Ref);
		iref->setCommunication(NONE);
		for(int j=0;j<MAX_ALIGN_DIM;j++){
			iref->setAmount(0,j,0);
			iref->setAmount(1,j,0);
			((forall_reference *)iref)->setAmount(j,0);
		}
	}
}

int dim_collapsed(SgArrayRefExp *array,int dim){
	Distribute_def *ddef=get_distdef(array->symbol());
	if(!ddef) return 1;
	Alignment_def *adef=get_aligndef(array->symbol());
	int pair_dim=adef?adef->getAlignPair(dim):dim;
	if (ddef->distCode(pair_dim)==NOP) return 1;
	return 0;
}

Indepdo_reference * appropriate_ref(SgStatement *s){
	int max=0;
	for(int i=0;i<s->numberOfAttributes(Indepdo_Ref);i++){
		Indepdo_reference *iref=(Indepdo_reference *)(s->attributeValue(i,Indepdo_Ref));
		SgExpression *aref=iref->getexpression();
                if(aref->variant()!=ARRAY_REF) continue;
		if(!iref->checkRegular()) continue;	
		SgArrayRefExp *array=(SgArrayRefExp *)aref;
		int sub_refed_loopvar=0;
		for(int j=0;j<array->numberOfSubscripts();j++){
			if(array->subscript(j)->numberOfAttributes(SUB_RANGE)&&!dim_collapsed(array,j)){
				sub_refed_loopvar=1;
				break;
			}
		}
		if(sub_refed_loopvar) continue;
		SgSymbol *arraysym=array->symbol();
		if(arraysym->numberOfAttributes(Inherit_Def)!=0) continue;
		Distribute_def *ddef=get_distdef(arraysym);	
//		if(!ddef) continue;//all collapsed
  		Processor_def *pdef = (Processor_def *)ddef->gettosymbol()->attributeValue(0, Proc_Def);
		ASSERT(pdef->getDim());
		int counter=0;
		for(int j=0;j<pdef->getDim();j++){	
			int pd=get_partitioned_dim(pdef,j, array);
			if(pd==-2) break;
			if(pd==-1) continue;//this dim is collapsed
        		int index = iref->indexNumberOnDim(pd);
			if(index==-1) continue;
			counter++;
		}
			
		iref->partitioned_sub_num=counter;
		if(max<counter) max=counter;
	}
//	if(max==0) return NULL;
//	printf("max_partitioned_dim : %d\n",max);
	for(int i=0;i<s->numberOfAttributes(Indepdo_Ref);i++){
		Indepdo_reference *iref=(Indepdo_reference *)(s->attributeValue(i,Indepdo_Ref));
		if(iref->partitioned_sub_num==max){
//			return iref;
			s->addAttribute(Indepdo_Lref,iref,sizeof(iref));
			detect_indepdo_reference(s,0);
			calc_communication_cost(s,iref);
			recover_indepdo_reference(s);
			s->deleteAllAttribute(Indepdo_Lref);
			
		}
	}
	int * min_cost=new int[5];
	Indepdo_reference * min_cost_iref;
	int first=1;
	for(int i=0;i<s->numberOfAttributes(Indepdo_Ref);i++){
		Indepdo_reference *iref=(Indepdo_reference *)(s->attributeValue(i,Indepdo_Ref));
		if(iref->partitioned_sub_num==max){
			SgArrayRefExp *array=(SgArrayRefExp *)iref->getexpression();
			int *cost=(int *)array->attributeValue(0,COM_COST);

			if(first){	
				for(int j=0;j<5;j++){ min_cost[j]=cost[j]; }
				min_cost_iref=iref;
				first=0;
			}
			else{
				if(cost[4]>min_cost[4]) ;//irreg
				else if(cost[3]+cost[2]>min_cost[3]+min_cost[2]) ;//remap+unknow
				else if(cost[1]>min_cost[1]) ;//shift
				else{
					for(int j=0;j<5;j++){ min_cost[j]=cost[j]; }
					min_cost_iref=iref;
				}
			}
		}
	}
	if(!min_cost_iref) ASSERT(0);
	return min_cost_iref;
} 

void get_indepdo_reference(SgStatement *s){	
	SgStatement * s1=s;
	while(s1->childList1(0)->variant()==INDEPENDENT_STMT&&s1->childList1(2)->variant()==ENDDO_STMT) s1=s1->childList1(1);
	s->addAttribute(Inmost_indepdo_loop,s1,sizeof(SgStatement));
	SgStatement *s2=s1->childList1(0);
	s->addAttribute(First_stmt_in_indepdo,s2,sizeof(SgStatement));
	int i=0;
	while(s2->variant()!=ENDDO_STMT){
		i++;
		s2=s1->childList1(i);
	} 
	s->addAttribute(Last_stmt_in_indepdo,s1->childList1(i-1),sizeof(SgStatement));
//for example,a HPF program like:
// ...
//!HPF$ INDEPENDENT
//do i=1,N
//!HPF$ INDEPENDENT
//	do j=1,M     <----Inmost_indepdo_loop
//		          |	A(i,j)=100	<----First_stmt_in_indepdo
// independent do body--->|	...
//   (indepdo_body)	  |	B(i,j)=C(i,j)+1998	<----Last_stmt_in_indepdo
//	end do
//end do
// ...
//a variable to record the sequence of a reference(array reference or var reference) in independent do body

	int ref_sequence=0;
	for(i=0;i<s1->numberOfChildrenList1()-2;i++){
//add all the references(array or variable) in independent do body to 
//statement s as Indepdo_Ref attribute  
		SgStatement *body=s1->childList1(i);
		analyse_indepdo_body(s,body,ref_sequence);
	}
	for(i=0;i<s->numberOfAttributes(Indepdo_Ref);i++){
		Indepdo_reference *iref=(Indepdo_reference *)s->attributeValue(i,Indepdo_Ref);
		find_same(s,iref,i);
	}

        Indepdo_header_def * ihdef= (Indepdo_header_def *) s->attributeValue(0, IHEDR_Def);
        for (i=0; i<ihdef->getindexnumber(); i++) {
               SgSymbol * index=ihdef->getindexsymb(i);
               index_indepdo_reference(i, index, s);
        };

//find array references with Left_Bit ref_attrib from Indepdo_Ref
//and add them to statement s as Indepdo_Lref attribute.
//data of array references with Left_Bit ref_attrib will be changed when 
//statement contain them executed.
//data of array references without Left_Bit ref_attrib will not be changed when 
//statement contain them executed.
//definition of Left_Bit,Right_Bit and LR_Bit locates in file "indep.h"

        Indepdo_reference *iref= appropriate_ref(s);

	if(iref){
        	s->addAttribute(Indepdo_Lref,iref,sizeof(Indepdo_reference));
        }

	if(s->numberOfAttributes(Indepdo_Lref)==0){
		printf("Lref must be created!\n");
		ASSERT(0);
		SgSymbol * dad_sym=s->getSymbolInCurrentScope(mixstring,"dad","indepdo_tmp_array");
		SgExpression *dad=new SgVarRefExp(dad_sym);
		SgSymbol * array_sym=s->getSymbolInCurrentScope("indepdo_tmp_array");
		SgArrayRefExp * array=new SgArrayRefExp(*array_sym);
		SgStatement *s1=s->controlParent();
		int variant=s1->variant();
		while(variant!=PROG_HEDR&&variant!=PROC_HEDR&&variant!=FUNC_HEDR&&variant!=MODULE_STMT){
			s1=s1->controlParent();
			variant=s1->variant();
		}
		ASSERT(s1);
		if(!s1->numberOfAttributes(Proc_Def)) ASSERT(0);
		int proc_dim=((Processor_def *)s1->attributeValue(0,Proc_Def))->getDim();
		Indepdo_header_def * ihdef=(Indepdo_header_def *)s->attributeValue(0,IHEDR_Def);
		int dist_dim=proc_dim<ihdef->getindexnumber()?proc_dim:ihdef->getindexnumber();
		for (i=0;i<dist_dim;i++){
			SgSymbol *sub_sym=ihdef->getindexsymb(i);
			SgExpression *sub=new SgVarRefExp(sub_sym);
			array->addSubscript(*sub);
		}	
		Indepdo_reference *iref=new Indepdo_reference(Left_Bit,0);
		iref->setExpr(array);
		for(i=0;i<dist_dim;i++){
			iref->setIndex(i,i,1);
            		SgExpression * stride = new SgValueExp(1);
            		SgExpression * offset = new SgValueExp(0);
		        iref->setstride(i, i, stride);
            		iref->setoffset(i, i, offset);
		}
                s->addAttribute(Indepdo_Lref,iref,sizeof(Indepdo_reference));
		s->addAttribute(Lref_created,NULL,0);
	}
}

void display_indepdo_reference_communication(SgStatement *s){
	printf("Array reference(s) in independent do:\n");
	int counter=0;
	for(int i=0;i<s->numberOfAttributes(Indepdo_Ref);i++){
                Indepdo_reference * iref=(Indepdo_reference *)s->attributeValue(i,Indepdo_Ref);
		if(iref->getexpression()->variant()==VAR_REF) continue;
		counter++;
                printf("\t%d.",counter);
		iref->getexpression()->unparsestdout();
                switch(iref->getCommunication()){
                case NONE:
                        printf("-------NONE!\n");
                        break;
                case SHIFT:
                        printf("-------SHIFT!\n");
                        break;
                case REMAP:
                        printf("-------REMAP!\n");
                        break;
                case UNKNOW:
                        printf("-------UNKNOW!\n");
                        break;
                case BROADCAST_DIM:
                        printf("-------BROADCAST_DIM!\n");
                        break;
                case BROADCAST_SCALAR:
                        printf("-------BROADCAST_SCALAR!\n");
                        break;
                case IRREG:
                        printf("-------IRREG!\n");
                        break;
		default:
			printf("-------OTHER COMMUNICATION!\n");   
                }
		if(iref->getexpression()->numberOfAttributes(CONDITION_ASSIGN))
			printf("\t (CONDITION_ASSIGN)\n");
	}

	printf("Total number of array reference(s):%d.\n",counter);
	
	Indepdo_reference *iref=(Indepdo_reference *) s->attributeValue(0,Indepdo_Lref);
	printf("\nComputation is partitioned by:");
	iref->getexpression()->unparsestdout();
	printf("\n");
	
}

void add_oc_read(SgStatement *s,SgCallStmt *call)//not used function
{
	int i;
	SgArrayRefExp *array=(SgArrayRefExp *)call->arg(0)->copyPtr();
        SgSymbol * arraysym=array->symbol();
              SgSymbol *dad=s->getSymbolInCurrentScope(mixstring,"dad",
                        arraysym->identifier());
                SgSymbol *memsym=s->getSymbolInCurrentScope(arraysym->
                        identifier());
                SgArrayRefExp *memExp=new SgArrayRefExp(*memsym);
		SgSymbol *hsym=get_ubound(arraysym,0)->symbol();
/*
		SgSymbol *subsym=s->getSymbolInCurrentScope("icol");
		SgExpression *sub=&(*(new SgVarRefExp(subsym))**(new SgVarRefExp(hsym)));
*/
		SgExpression *sub = array->subscript(0);
                SgSymbol *stridesym=s->getSymbolInCurrentScope(mixstring,"oc_stride",arraysym->identifier());
                SgSymbol *numbersym=s->getSymbolInCurrentScope(mixstring,"oc_number",arraysym->identifier());
                SgStatement *ocreadStmt=make_oc_read(s,dad,memExp,sub,stridesym,numbersym);
		SgValueExp *one=new SgValueExp(1);
                for(i=0;i<2;i++){
                        SgExpression *subscrpt=new SgValueExp(i+1);
                        subscrpt=new SgExpression(EXPR_LIST,subscrpt,NULL,NULL);                        SgArrayRefExp *numberexp=new SgArrayRefExp(numbersym->copy());
                        numberexp->setSubscripts(*subscrpt);
                        SgAssignStmt *assignStmt;
			if(i==0) assignStmt=new SgAssignStmt(*numberexp,*(new SgVarRefExp(hsym)));
                        else assignStmt=new SgAssignStmt(*numberexp,*one);
       
			call->insertStmtBefore(*assignStmt,*call->controlParent());
                }
                for(i=0;i<2;i++){
                        SgExpression *subscrpt=new SgValueExp(i+1);
                        subscrpt=new SgExpression(EXPR_LIST,subscrpt,NULL,NULL);                        SgArrayRefExp *stridexp=new SgArrayRefExp(stridesym->copy());
                        stridexp->setSubscripts(*subscrpt);
                        SgAssignStmt *assignStmt;
			if(i>0) assignStmt=new SgAssignStmt(*stridexp,*(new SgVarRefExp(hsym)));
                        else assignStmt=new SgAssignStmt(*stridexp,*one);
			call->insertStmtBefore(*assignStmt,*call->controlParent());
                }
		call->insertStmtBefore(*ocreadStmt,*call->controlParent());

}

void add_oc_write(SgStatement *s,SgCallStmt *call)//not used function
{
	int i;
        SgArrayRefExp *array=(SgArrayRefExp *)call->arg(0);
        SgSymbol * arraysym=array->symbol();
              SgSymbol *dad=s->getSymbolInCurrentScope(mixstring,"dad",
                        arraysym->identifier());
                SgSymbol *memsym=s->getSymbolInCurrentScope(arraysym->
                        identifier());
                SgArrayRefExp *memExp=new SgArrayRefExp(*memsym);
                SgSymbol *hsym=get_ubound(arraysym,0)->symbol();
/*
                SgSymbol *subsym=s->getSymbolInCurrentScope("icol");
                SgExpression *sub=&(*(new SgVarRefExp(subsym))**(new SgVarRefExp(hsym)));
*/
		SgExpression *sub = array->subscript(0);
                SgSymbol *stridesym=s->getSymbolInCurrentScope(mixstring,"oc_stride",arraysym->identifier());
                SgSymbol *numbersym=s->getSymbolInCurrentScope(mixstring,"oc_number",arraysym->identifier());
                SgStatement *ocwriteStmt=make_oc_write(s,dad,memExp,sub,stridesym,numbersym);
                call->insertStmtAfter(*ocwriteStmt,*call->controlParent());
                SgValueExp *one=new SgValueExp(1);
                for(i=0;i<2;i++){
                        SgExpression *subscrpt=new SgValueExp(i+1);
                        subscrpt=new SgExpression(EXPR_LIST,subscrpt,NULL,NULL);                        SgArrayRefExp *numberexp=new SgArrayRefExp(numbersym->copy());
                        numberexp->setSubscripts(*subscrpt);
                        SgAssignStmt *assignStmt;
                        if(i==0) assignStmt=new SgAssignStmt(*numberexp,*(new SgVarRefExp(hsym)));
                        else assignStmt=new SgAssignStmt(*numberexp,*one);

                        call->insertStmtAfter(*assignStmt,*call->controlParent());
                }
                for(i=0;i<2;i++){
                        SgExpression *subscrpt=new SgValueExp(i+1);
                        subscrpt=new SgExpression(EXPR_LIST,subscrpt,NULL,NULL);                        SgArrayRefExp *stridexp=new SgArrayRefExp(stridesym->copy());
                        stridexp->setSubscripts(*subscrpt);
                        SgAssignStmt *assignStmt;
                        if(i>0) assignStmt=new SgAssignStmt(*stridexp,*(new SgVarRefExp(hsym)));
                        else assignStmt=new SgAssignStmt(*stridexp,*one);
                        call->insertStmtAfter(*assignStmt,*call->controlParent());
                }

}

void dispose_indepdo_oc_reference(SgStatement *s){//not used function
	int i=0;
	 //  zheng.gb ????
	while(s->childList1(i) && s->childList1(i)->variant()!=LOGIF_NODE) i++;
        if (!s->childList1(i)) return;
        if (s->childList1(i)->variant()!=LOGIF_NODE) return;
	SgCallStmt *call=isSgCallStmt(s->childList1(i)->childList1(0));
        if (call == NULL) return;
	SgArrayRefExp *array=(SgArrayRefExp *)call->arg(0);
	SgSymbol * arraysym=array->symbol();
	if(is_out_of_core(arraysym) == 0) return;
        // 
	add_oc_read(s,call);
	add_oc_write(s,call);
        //
	SgArrayRefExp *newarray=new SgArrayRefExp(*arraysym);
	array->replace(*newarray);
}

void index_indepdo_reference(int indexdim, SgSymbol * index, SgStatement * s)
{
    for (int i=0; i<s->numberOfAttributes(Indepdo_Ref); i++) {
      Indepdo_reference * iref= (Indepdo_reference *) s->attributeValue(i, Indepdo_Ref);

      int indexlevel;

      SgExpression * irexp=iref->getexpression();

      switch(irexp->variant()) {
      case VAR_REF:
        indexlevel = getreflevel(index, irexp);
        iref->setIndex(0, indexdim, indexlevel);
        break;
      case ARRAY_REF:{
        SgArrayRefExp * arrayexp=(SgArrayRefExp *) irexp;

        SgSymbol * arraysym=arrayexp->symbol();

        for (int dimI=0; dimI<arrayexp->numberOfSubscripts();dimI++) {
          indexlevel=getreflevel(index, arrayexp->subscript(dimI));

          iref->setIndex(dimI, indexdim, indexlevel);
          // if possible, try to get stride and offset;

          if (indexlevel==1) {
            SgExpression *exp=coefficient(arrayexp->subscript(dimI), index);
            SgExpression * stride = exp->lhs();
            SgExpression * offset = exp->rhs();
            stride = calculateExp(stride);
            offset = calculateExp(offset);

            iref->setstride(dimI, indexdim, stride);
            iref->setoffset(dimI, indexdim, offset);
          }
        }
        break;
        }
      default:
        printf("index_indepdo_reference::Expression not touched!\n");
        break;
    }
  }
}

/*******************************************************************************
			functions to analyse communication
				of references in 
				independent do
*******************************************************************************/

void set_indepdo_remap_mapping(Indepdo_reference * lhsref, Indepdo_reference * rhsref)
{
        int i,j;

        switch (rhsref->getCommunication())
        {
        case UNKNOW:
        case REMAP:
        case BROADCAST_DIM:
        case BROADCAST_SCALAR:
                SgArrayRefExp * lhsarray = (SgArrayRefExp *) lhsref->getexpression();
                SgArrayRefExp * rhsarray = (SgArrayRefExp *) rhsref->getexpression();
                for (i=0; i<MAX_ALIGN_DIM; i++)
                {
                        int dim=rhsref->indexNumberOnDim(i);
                        if (dim==-1) {
                                ((forall_reference *)rhsref)->setAmount(i, -1);
                                continue;
                        }
                        for (j=0; j<lhsarray->numberOfSubscripts(); j++)
                                if (lhsref->indexNumberOnDim(j)==dim)
                                        break;
                        ASSERT(lhsref->indexNumberOnDim(j)==dim);//bug exist?
                        ((forall_reference *)rhsref)->setAmount(i, j);
                }
                break;
        }
}

void  set_indepdo_unknow_ghostarea(SgStatement *s,Indepdo_reference *rhsref)
{
        Indepdo_reference *lhsref = (Indepdo_reference *)s->attributeValue(0, Indepdo_Lref);
        int ishift = 1;

        if ( opt_strategy & RUNTIMECOMM )
        if (rhsref->getCommunication() == UNKNOW)
        {
          SgSymbol *array = rhsref->getexpression()->symbol();
          SgArrayType *type = isSgArrayType(array->type());
          ASSERT(type);
          int numDim = type->dimension();
          int shift_ok = shift_is_ok(s,array);
          if (shift_ok == 0) return;

          // default ghostsize is 4
          int ghostSize = 4;
            // check if we have defined SHADOW directive
          Shadow_def * dsdef = get_defined_shadow(array);
            // create a new shadow def to this symbol
          Shadow_def * sdef = new Shadow_def (DETECTED);
          for ( int iDim = 0; iDim < numDim; iDim++) {
                int lgSize=0,ugSize=0;
                int need_ghost=1;
                // try best to reduce the ghostarea .
                if (array_dim_collapsed(array,iDim) == 1) need_ghost=0;
                // stride not same
                if (rhsref->indexNumberOnDim(iDim) != -1) {
                        int indexNumber = rhsref->indexNumberOnDim(iDim);
                        int rDim = lhsref->dimNumberOnIndex(indexNumber);
                        if (rDim != -1) {
                                SgExpression *rstride = rhsref->getstride(iDim,indexNumber);
                                SgExpression *lstride = lhsref->getstride(rDim,indexNumber);
                                if (rstride->isInteger() && lstride->isInteger() )
                                {
                                        if (rstride->valueInteger() != lstride->valueInteger())
                                                need_ghost=0;
                                }
                        }
                }
                if (need_ghost) {
                  if (dsdef) {
                        lgSize = dsdef->getLower(iDim);
                       ugSize = dsdef->getUpper(iDim);
                  }
                  else {
                        lgSize = ugSize = ghostSize;
                  }
                }
                sdef->setUpper(iDim, lgSize);
                sdef->setLower(iDim, ugSize);
                  // this dim require SHIFT
                if (rhsref->indexNumberOnDim(iDim) == -1)
                        ishift = 0;
          };
          sdef->setScope(s);
          array->addAttribute(Shift_Def,(void *) sdef, sizeof(Shadow_def));
//printf("set global array:%s,id:%d\n",array->identifier(),array->id());

          if (rhsref->hasScalarDim() && ishift)
                  rhsref->setIShift();

            // set Shadow_def
          rhsref->setShadow(sdef);
        }
}


int analyseExp(SgExpression *e,int &t1,int &t2,stack stk){
	SgExpression *e1,*e2;
	e1=e->copyPtr();
	e2=e->copyPtr();
	int i;
	for(i=0;i<stk.elements();i++){
		loop_var *loopvar=stk.get_loopvar(i);		
		SgSymbol *loopsym=loopvar->getsymbol();
		SgVarRefExp *loopExp=new SgVarRefExp(loopsym);
		if(find_and_replace(e,loopExp,NULL)){
			find_and_replace(e1,loopExp,loopvar->get_start());
			find_and_replace(e2,loopExp,loopvar->get_end());
			break;
		}		
	}
	calcExp(e1);
	calcExp(e2);
	if(!(e1->isInteger())) return 0;
	t1=e1->valueInteger();
	t2=e2->valueInteger();
	return 1;
}

int min(int *v,int num){
	if(num==0) return 0;
	int tmp=v[0];
	for(int i=1;i<num;i++){
		if(v[num]<tmp) tmp=v[num];
	}
	return tmp;
}

int max(int *v,int num){
	if(num==0) return 0;
	int tmp=v[0];
	for(int i=1;i<num;i++){
		if(v[num]>tmp) tmp=v[num];
	}
	return tmp;
}

int carefully_detect(SgStatement *s,int pdim,Indepdo_reference *lhsref,int lpd,Distribute_def *lddef,Alignment_def * ladef,Indepdo_reference *rhsref,int rpd,Distribute_def *rddef,Alignment_def *radef,int index,int &amount,int &amount1){
 	
  Indepdo_header_def * ihdef = (Indepdo_header_def *) s->attributeValue(0, IHEDR_Def);
  SgSymbol *indexsym=ihdef->getindexsymb(index);
  SgVarRefExp *indexexp=new SgVarRefExp(indexsym);

  Processor_def *pdef = (Processor_def *)lddef->gettosymbol()->attributeValue(0, Proc_Def);
  int lpd_template=ladef?ladef->getAlignPair(lpd):0;
  int rpd_template=radef?radef->getAlignPair(rpd):0;
  SgSymbol *lhs_template=(SgSymbol *)(ladef?ladef->gettosymbol():NULL);
  SgSymbol *rhs_template=(SgSymbol *)(radef?radef->gettosymbol():NULL);

  SgArrayRefExp * lhsarray = (SgArrayRefExp *) lhsref->getexpression();
  SgSymbol * lhssymb = lhsarray->symbol();
  SgExpression *ldim_length;
  if(!ladef) ldim_length=&(*get_ubound(lhssymb,lpd)-*get_lbound(lhssymb,lpd)+ * new SgValueExp(1));
  else ldim_length=&(*get_ubound(lhs_template,lpd_template)-*get_lbound(lhs_template,lpd_template)+ * new SgValueExp(1));
  calcExp(ldim_length);

  SgArrayRefExp * rhsarray = (SgArrayRefExp *) rhsref->getexpression();
  SgSymbol * rhssymb = rhsarray->symbol();
  SgExpression *rdim_length;
  if(!radef) rdim_length=&(*get_ubound(rhssymb,lpd)-*get_lbound(rhssymb,rpd)+ * new SgValueExp(1));
  else rdim_length=&(*get_ubound(rhs_template,rpd_template)-*get_lbound(rhs_template,rpd_template) + * new SgValueExp(1));
  calcExp(rdim_length);

  int ldist_code=ladef?lddef->distCode(lpd_template):lddef->distCode(lpd);
  int rdist_code=radef?rddef->distCode(rpd_template):rddef->distCode(rpd);
  
  SgExpression *lp_sub,*rp_sub;
  lp_sub=lhsarray->subscript(lpd)->copyPtr();
  if(ladef) lp_sub=&(* lp_sub * *(ladef->getStride(lpd)->copyPtr()) + *(ladef->getOffset(lpd)->copyPtr()));
  rp_sub=rhsarray->subscript(rpd)->copyPtr();
  if(radef) rp_sub=&(* rp_sub * *(radef->getStride(rpd)->copyPtr()) + *(radef->getOffset(rpd)->copyPtr()));

  SgExpression *la,*lb,*ra,*rb;
  get_coef(lp_sub,indexexp,la,lb);
  get_coef(rp_sub,indexexp,ra,rb);
  SgExpression *lt_s=ladef?get_lbound(lhs_template,lpd_template):get_lbound(lhssymb,lpd);
  SgExpression *rt_s=radef?get_lbound(rhs_template,rpd_template):get_lbound(rhssymb,rpd);

 //check to see if communication is not needed

 	SgExpression *index_lb;
	SgExpression *index_ub;
	SgExpression *index_strd;
	if(index!=-1){
		index_lb=ihdef->getindextriple(index,0);
		index_ub=ihdef->getindextriple(index,1);
		index_strd=ihdef->getindextriple(index,2);
		if(!index_strd) index_strd=new SgValueExp(1);
	}
	else{
		index_lb=new SgValueExp(0);
		index_ub=new SgValueExp(0);
		index_strd=new SgValueExp(0);
	} 
	SgExpression *numProcs = NULL;
	if (lddef->getProcs())
		numProcs = lddef->getProcSize(pdim);
	else
		numProcs = &(*pdef->getEnd(pdim) - *pdef->getStart(pdim) + *new SgValueExp(1) );

	int proc_dif=0;
	if((!ldim_length->isInteger())||(!rdim_length->isInteger())||(!index_lb->isInteger())||(!index_ub->isInteger())||(!index_strd->isInteger())||(!numProcs->isInteger())||(!la->isInteger())||(!ra->isInteger())||(!lb->isInteger())||(!rb->isInteger())||(!rt_s->isInteger())||(!lt_s->isInteger())) ;
	else{
		int rdim_len=rdim_length->valueInteger();
		int ldim_len=ldim_length->valueInteger();
		int proc_dim_len=numProcs->valueInteger();

		int rblock=rdim_len/proc_dim_len;
		if(rblock*proc_dim_len<rdim_len) rblock++;
		int lblock=ldim_len/proc_dim_len;
		if(lblock*proc_dim_len<ldim_len) lblock++;


		int idx_lb=index_lb->valueInteger();
		int idx_ub=index_ub->valueInteger();
		int idx_strd=index_strd->valueInteger();
		int ra_v=ra->valueInteger();
		int rb_v=rb->valueInteger();
		int la_v=la->valueInteger();
		int lb_v=lb->valueInteger();
		int lt_strt=lt_s->valueInteger();
		int rt_strt=rt_s->valueInteger();
		int no_com=1;
		int tmp1=ra_v*idx_lb+rb_v-rt_strt;
		int tmp2=la_v*idx_lb+lb_v-lt_strt;
		int r_step=ra_v*idx_strd;
		int l_step=la_v*idx_strd;
		int rproc,lproc;
		if(r_step>=0){
		while(tmp1<=ra_v*idx_ub+rb_v-rt_strt+1&&tmp2<=la_v*idx_ub+lb_v-lt_strt+1){
			if(rdist_code==BLOCK) rproc=tmp1/rblock;
			else if(rdist_code==CYCLIC) rproc=tmp1%proc_dim_len;
			else ASSERT(0);
			if(ldist_code==BLOCK) lproc=tmp2/lblock;
			else if(ldist_code==CYCLIC) lproc=tmp2%proc_dim_len;
			else ASSERT(0);
			if(rproc != lproc){
				no_com=0;
				break;
			}
			if(r_step==0&&l_step==0) break;
			tmp1+=r_step;
			tmp2+=l_step;
		}
		}
		else{
		while(tmp1>=ra_v*idx_ub+rb_v-rt_strt+1&&tmp2>=la_v*idx_ub+lb_v-lt_strt+1){
			if(rdist_code==BLOCK) rproc=tmp1/rblock;
			else if(rdist_code==CYCLIC) rproc=tmp1%proc_dim_len;
			else ASSERT(0);
			if(ldist_code==BLOCK) lproc=tmp2/lblock;
			else if(ldist_code==CYCLIC) lproc=tmp2%proc_dim_len;
			else ASSERT(0);
			if(rproc != lproc){
				no_com=0;
				break;
			}
			tmp1+=r_step;
			tmp2+=l_step;
		}
		}
		if(no_com){
			amount=0;
			amount1=0;
			return 1;
		}
		else proc_dif=1;
  }

//check finished

  if(ldist_code==BLOCK&&rdist_code==BLOCK) ;
  else{
	if(rhsarray->subscript(rpd)->numberOfAttributes(SUB_RANGE)) return 3;//irreg
	if(proc_dif) return 2;//remap
	return 0;//unknow	
  }

  SgExpression *t=&(*ldim_length * *ra - *rdim_length * *la);
  computeExp(t);
  if((!t->isInteger())){
	if(rhsarray->subscript(rpd)->numberOfAttributes(SUB_RANGE)) return 3;//irreg
	return 0;//unknow
  }
  if(t->valueInteger()!=0)  return 2;//remap  
  SgExpression *tmp;
  if(la->isInteger()&&la->valueInteger()==0){
  	tmp=&(*rdim_length / *ldim_length);
	divide_exp(tmp);
  }
  else tmp=&(*ra / *la);

  SgExpression *e=&(*rb-((*lb-*lt_s) * *tmp + *rt_s));
  int t1,t2;
  calcExp(e);
  if(e->isInteger()){
	amount=e->valueInteger();
	amount1=0;
	return 1;
  }
  else{
	if(rhsarray->subscript(rpd)->numberOfAttributes(SUB_RANGE)){
		stack *pstk=(stack *)rhsarray->attributeValue(0,LOOPVAR_STK);
	  	if(analyseExp(e,t1,t2,*pstk)){
			amount=t1;
			amount1=t2;
			return 1;
		}
		else return 3;//irreg
	}
	else return 0;//unknow
  }
}

void detect_indepdo_communication(SgStatement * s, int counter,int flag)
{
  Indepdo_header_def * ihdef = (Indepdo_header_def *) s->attributeValue(0, IHEDR_Def);

  Indepdo_reference * lhsref = (Indepdo_reference *)s->attributeValue(0, Indepdo_Lref);
  SgArrayRefExp * lhsarray = (SgArrayRefExp *) lhsref->getexpression();
  SgSymbol * lhssymb = lhsarray->symbol();

  Indepdo_reference * rhsref = (Indepdo_reference *)s->attributeValue(counter,
Indepdo_Ref);
  SgArrayRefExp * rhsarray = (SgArrayRefExp *) rhsref->getexpression();
  SgSymbol * rhssymb = rhsarray->symbol();

  Alignment_def  *ladef = NULL, *radef = NULL;
  Distribute_def *lddef = NULL, *rddef = NULL;

  int ishift = 1;

  // RHS
  if (rhssymb->numberOfAttributes(Align_Def)!=0) {
        radef = (Alignment_def *)(rhssymb->attributeValue(0,Align_Def));
        SgSymbol * rt = radef->gettosymbol();
        rddef = (Distribute_def *) (rt->getAttribute(0, Dist_Def)->getAttributeData());
  }
  else {
        if (rhssymb->numberOfAttributes(Dist_Def) == 0) {
           // INHERIT
           if (rhssymb->numberOfAttributes(Inherit_Def)!=0){
		if(rhsarray->numberOfAttributes(SUB_REFED_LOOPVAR)) 
			rhsref->setCommunication(IRREG);
		else 
	                rhsref->setCommunication(UNKNOW);
	   }
           else{ // default mapping (collapsed)
		if(rhsref->get_ref_attrib()&Left_Bit){
			if(rhsarray->numberOfAttributes(SUB_REFED_LOOPVAR))
        	                rhsref->setCommunication(IRREG);
	                else{
				if(array_all_collapsed(lhssymb)==1) rhsref->setCommunication(NONE);
	                	else rhsref->setCommunication(REMAP);
			}
		}
		else
	                rhsref->setCommunication(NONE);
	   }
           return;
        }
        else {
           rddef = (Distribute_def *)rhssymb->attributeValue(0, Dist_Def);
        }
  }
  // LHS
  if (lhssymb->numberOfAttributes(Align_Def)!=0) {
        ladef = (Alignment_def *)(lhssymb->attributeValue(0,Align_Def));
        SgSymbol * lt = ladef->gettosymbol();
        lddef = (Distribute_def *)lt->attributeValue(0, Dist_Def);
  }
  else {
        if (lhssymb->numberOfAttributes(Dist_Def) == 0) {
           // INHERIT
           if (lhssymb->numberOfAttributes(Inherit_Def)!=0){
		if(rhsarray->numberOfAttributes(SUB_REFED_LOOPVAR))
                        rhsref->setCommunication(IRREG);
                else
	                rhsref->setCommunication(UNKNOW);
	   }
           else{ 
		if(array_all_collapsed(rhssymb)==1) rhsref->setCommunication(NONE);
	       	else ASSERT(0);//somthing is wrong!
		exit(1);
	   }	
           return;
        }
        else {
           lddef = (Distribute_def *)lhssymb->attributeValue(0, Dist_Def);
        }
  }

  // try to decide if we can use shift, which is better than remap.

  if (lddef->gettosymbol()!=rddef->gettosymbol())  {
        printf("Error: Data aligned to different processors!\n");
        ASSERT(0);
	exit(1);
  }

  Processor_def *pdef = (Processor_def *)lddef->gettosymbol()->attributeValue(0, Proc_Def);
    //  check along dimension of processor
  for (int i=0; i< pdef->getDim(); i++) {

        int lpd=get_partitioned_dim(pdef,i, lhsarray);
        int rpd=get_partitioned_dim(pdef,i, rhsarray);
//printf("lpd=%d,rpd=%d\n",lpd,rpd);

          // rhs is all collapsed
        if (rpd==-2) {
		if(rhsref->get_ref_attrib()&Left_Bit){
			if(array_all_collapsed(lhssymb)==1) rhsref->setCommunication(NONE);
	               	else rhsref->setCommunication(REMAP);
		}
                continue;
        };

        if (lpd==-2) {//something is wrong!
//		printf("flag:%d,lref:%s\n",flag,lhssymb->identifier());
		ASSERT(0);
                return;
        }

          //  align a(i) with T(i,j)   ;  distribute T(block,block) onto P(2,2)
          //  consider the second dim of P
        if (lpd == -1 || rpd == -1)
        {
                if (rpd == -1) {        // this dim is collapsed, check next one.
			if(lpd!=-1){
			if(rhsref->get_ref_attrib()&Left_Bit)
	                        rhsref->setCommunication(REMAP);
			}
                        continue;
                }
                else {
			if(rhsarray->subscript(rpd)->numberOfAttributes(SUB_RANGE)){
				rhsref->setCommunication(IRREG);
				return ;
			}
                        rhsref->setCommunication(REMAP);
                        continue;
                }
        }

        int lindex = lhsref->indexNumberOnDim(lpd);
        int rindex = rhsref->indexNumberOnDim(rpd);

          // cannot compare if the independent do index is not same
        if (lindex != rindex) {
		if(rhsarray->subscript(rpd)->numberOfAttributes(SUB_RANGE)){
                                rhsref->setCommunication(IRREG);
                                return ;
                }
                rhsref->setCommunication(REMAP);
		continue;
        }

          // now the lpd and rpd contain same independent do index or both scalar
        int amount,amount1;
	int result;
	result=carefully_detect(s,i,lhsref,lpd,lddef,ladef,rhsref,rpd,rddef,radef,lindex,amount,amount1);
	switch(result){
		case 0:
			if(rhsref->getCommunication()==REMAP) ;
			else rhsref->setCommunication(UNKNOW);
			continue;
		case 1:
			if (rhsref->getCommunication() != UNKNOW&&
				rhsref->getCommunication()!=REMAP)
                	{
                		rhsref->setCommunication(SHIFT);
                		rhsref->setAmount(0,rpd, amount);
                		rhsref->setAmount(1,rpd, amount1);
                	}
			continue;
		case 2:
			rhsref->setCommunication(REMAP);
			continue;
		case 3:
			rhsref->setCommunication(IRREG);
                        return;
	}

  }   // end of for each dim

    // have tried best to exclude REMAP from UNKNOW
  if (rhsref->getCommunication() == UNKNOW) return;

    // check shift zero;
  if (rhsref->getCommunication()==SHIFT) {
    int move=0;
    for (int i=0; i<MAX_ALIGN_DIM; i++) {
      if (((forall_reference *)rhsref)->getAmount(i)!=0) {
        move=1;
        break;
      }
    }
    if (move==0){
      rhsref->setCommunication(NONE);
      return;
    }
    else if(is_dummy(s,rhssymb)){//because dummy can not have shadow area
	if(rhsarray->numberOfAttributes(LOOPVAR_STK)) rhsref->setCommunication(IRREG);
        else rhsref->setCommunication(REMAP);
        return;
   }
  }

  // remap cyclic.
  if (rhsref->getCommunication()==SHIFT) {
    for (int i=0; i<MAX_ALIGN_DIM; i++) {
      if (((forall_reference *)rhsref)->getAmount(i)!=0) {
        if (rddef->distCode(i)==CYCLIC) {
          rhsref->setCommunication(REMAP);
printf(" reset as remap(cyclic), %d th array reference\n",i);
          break;
        }
      }
    }
  }

  // Record template shadow  size
  if (rhsref->getCommunication()==SHIFT)  {


    Shadow_def * dsdef = get_defined_shadow(rhssymb);

    int ghostSize = 30;

    int shadow=1;
    for(int num=0;num<2;num++){
    for ( int dim =0; dim < MAX_ALIGN_DIM; dim++) {
      if (dsdef) {      // SHADOW directive
        int gSize = rhsref->getAmount(num,dim);
        if (gSize>0) {
                if (gSize > dsdef->getUpper(dim)) shadow=0;
        }
        else if (gSize<0) {
                if (-gSize > dsdef->getLower(dim)) shadow=0;
             }
      }
      else if ( abs(rhsref->getAmount(num,dim)) > ghostSize ) {
        shadow=0;
        break;
       }
    }
    }

    if (shadow == 0) rhsref->setCommunication(REMAP);

    if (!flag) return;
      // create Shadow_def(DETECTED)
    if (shadow)
    {
      for(int num=0;num<2;num++){
      Shift_def * sdef = new Shift_def (DETECTED);

      for ( int iDim = 0; iDim < MAX_ALIGN_DIM; iDim++) {
        int gSize = rhsref->getAmount(num,iDim);
        if (gSize>0)
          sdef->setUpper(iDim, abs(gSize));
        else
          sdef->setLower(iDim, abs(gSize));
      };
	
      fill_shift_section(s,counter,sdef,num);

      sdef->setScope(s);
      sdef->shift_iref=rhsref;
      rhssymb->addAttribute(Shift_Def,(void *) sdef, sizeof(Shift_def));
      rhssymb->addAttribute(Shad_Def,(void *) sdef, sizeof(Shift_def));
      }
    }
  }

}

void detect_indepdo_reference(SgStatement * s,int flag)
//if flag==0 means not really detect
{
  Indepdo_header_def * ihdef = (Indepdo_header_def *) s->getAttribute(0, IHEDR_Def)->getAttributeData();

    int i;

      for (i=0; i<s->numberOfAttributes(Indepdo_Ref); i++) {
        Indepdo_reference *iref = (Indepdo_reference *) s->attributeValue(i, Indepdo_Ref);

        if (!iref->checkRegular()) {
          iref->setCommunication(IRREG);
          if (flag) printf("Irregular independent do reference - no.%d!\n",i);
        }
      };

      Indepdo_reference * lhsref = (Indepdo_reference *) s->attributeValue(0, Indepdo_Lref);
      SgSymbol *lhsSymb = lhsref->getexpression()->symbol();
	SgArrayRefExp *lhsarray=(SgArrayRefExp *)lhsref->getexpression();

      // check if the dim of Lhs is equal to the index number
      if (lhsref->numberOfDiffIndex() != ihdef->getindexnumber()){
        if(flag) printf("Warning: In independent do statement, write to Lhs more than twice.\n");
      }

      for (i=0; i<s->numberOfAttributes(Indepdo_Ref); i++) {
        Indepdo_reference *rhsref = (Indepdo_reference *)s->attributeValue(i, Indepdo_Ref);
//        if(!(rhsref->get_ref_attrib()&Right_Bit)) continue;

        SgArrayRefExp *rhsArray =(SgArrayRefExp *)rhsref->getexpression();
        SgSymbol *rhsSymb = rhsArray->symbol();

        if (rhsArray->variant()==ARRAY_REF) {

            // already set to irregular
        if (rhsref->getCommunication() != NONE) continue;

	if(rhsref->pre_ref!=-1&&(!(rhsref->get_ref_attrib()&Left_Bit))){
		rhsref->setCommunication(NONE);
		continue;
	}
            // if rhs is the same as lhs , none communication
	Indepdo_reference *lref = (Indepdo_reference *)s->attributeValue(0, Indepdo_Lref);
          if (*lref->getexpression() == *rhsref->getexpression())
          {
                rhsref->setCommunication(NONE);
                continue;
          }
          if (is_resident(rhsSymb) == 1)
          {
                rhsref->setCommunication(NONE);
          }
          else
          if (is_dynamic(rhsSymb) || is_dynamic(lhsSymb) ||
              is_pointer(rhsSymb) || is_pointer(lhsSymb) ||
              is_allocatable(rhsSymb) || is_allocatable(lhsSymb) )
          {
		if(rhsArray->numberOfAttributes(SUB_REFED_LOOPVAR))
                        rhsref->setCommunication(IRREG);
                else
     	        	rhsref->setCommunication(UNKNOW);
          }
          else{
               	detect_indepdo_communication(s, i,flag);
	  }

          if (flag) set_indepdo_remap_mapping(lhsref,rhsref);

          if (flag) set_indepdo_unknow_ghostarea(s,rhsref);

	  if(rhsref->pre_ref!=-1&&(rhsref->get_ref_attrib()&Left_Bit)){
		Indepdo_reference *pre_iref=(Indepdo_reference *)s->attributeValue(rhsref->pre_ref,Indepdo_Ref);
		if(rhsref->getCommunication()==pre_iref->getCommunication()){
			rhsref->setCommunication(NONE);
			if (flag) pre_iref->add_ref_attrib(rhsref->get_ref_attrib());
		}
	  }

        } 

      };  

}
